#ifndef MATRIX_H_DEFINED
#define MATRIX_H_DEFINED

typedef struct 
{
	double** M;
	int n;
	int m;
} Matrix; 


Matrix* MatrixNew (int n, int m);
Matrix* MatrixCopy (Matrix* A);
Matrix* MatrixE (int n);
void MatrixSetRow (Matrix* A, int i, ...);
void MatrixGetRow (Matrix* A, int i, double* a);
void MatrixSetColumn (Matrix* A, int j, ...);
void MatrixGetColumn (Matrix* A, int j, double* a);
void MatrixSetElement (Matrix* A, int i, int j, double a);
double MatrixElement (Matrix* A, int i, int j);
void MatrixDelete (Matrix* M);
Matrix* MatrixMult (Matrix* A, Matrix* B);
Matrix* MatrixTranspose (Matrix* A);
void MatrixPrint (Matrix* A);
int MatrixRank (Matrix* A);
double MatrixDeterminant (Matrix* A);
Matrix* MatrixSolve (Matrix* A, Matrix* B);
Matrix* MatrixInverse (Matrix* A);

#endif
